AOZ Studio Beta - Bug #462

Float Variables passed to procedure as a parameter aren't handled correctly.
09/01/2020 07:00 PM - David Baldwin
Description

Float Variables passed to procedure as a parameter aren't handled correctly.

/' If A# is declared in procedure as 0.5, and not passed as a parameter, it works fine
#splashScreen:False

TEST[0.5]

Procedure TEST[A#]

Add A#,0.2

Print A#;" Should be 0.7"

Add A#,-0.2

Print A#;" Should be 0.5 (or at least 0.3 as last add was ignored!)"

End Proc

History

#1 - 09/01/2020 07:33 PM - Brian Flanagan

Verified... and | at least have it narrowed down.
It has to do with using the parameter passed directly.
If we set a local variable to the parameter value vs. using the parameter directly, then it works. See below:

// Inline the code works fine:
A#=0.5

Fix 1

Print "A#=";A#

Add A#,0.2

Print "Add A#,0.2=";A#

Add A#,-0.2

Print "Add A#,-0.2=";A#

Print

Print "Now the procedure:"

TEST[0.5] ' using the parameter variable fails.
Print

Print "And the second procedure:"

TEST2[0.5] ' re-assigning a local variable works.

// In the procedure it fails miserably!
Procedure TEST[A#]

Print "A# = ";A#

Add A#,0.2 // 0.7

Print "Add A#,0.2=";A#;" (should be 0.7)"

Add A#,-0.2

Print "Add A#,-0.2=";A#;" (should be 0.5)"
End Proc

// In this procedure it works.
Procedure TEST2 [B#]

A#=B#

Print "A# = ";A#

Add A#,0.2 // 0.7

Print "Add A#,0.2=";A#;" (should be 0.7)"

Add A#,-0.2

Print "Add A#,-0.2=";A#;" (should be 0.5)"
End Proc
#2 - 09/01/2020 09:32 PM - David Baldwin

Narrowed it down? That was exactly what | said.

#3 - 09/16/2020 06:53 PM - Brian Flanagan
- Estimated time set to 1:00 h
- Affected version changed from 0.9.9.4-r3 to Beta RC2

Sorry, | guess you did say the same thing! ;-)

It was just the thought process | was in. | think | know what's happening now. It looks like the floating point type is not being set on the parameters,
but it is on the local variables. I'm checking with Francois now find out where to make the change.

#4 - 09/27/2020 05:35 PM - Francois Lionet

- Status changed from New to Resolved
Fixed!

#5 - 09/29/2020 09:25 PM - David Baldwin

- Status changed from Resolved to Closed
